{
  Autor: Michael Springwald
  Erstellt am: Mittwoch den 22.Oktober.2008
  Änderungen
   -------------------------------------------------------------
01 - Dienstag, 28.Oktober.2008   - Freitag, 31.Oktober.2008    -
   -------------------------------------------------------------
02 - Samstag, 01.Nov.2008        - Donnerstag, 20.November.2008-
   -------------------------------------------------------------
03 - Freitag, 21.Nov.2008        - Samstag, 22.Nov.2008        -
   -------------------------------------------------------------
04 -                             -                             -
   -------------------------------------------------------------
05 -                             -                             -
   -------------------------------------------------------------

}

unit uPlListBox;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Controls, Graphics, LCLType, LCLIntf, LCLProc,
  LMessages,Messages,
  uPLlinesList;

type

  { TPlListBox }

  TPlListBox = class(TCustomControl)
  private

  protected

  public
    Lines:TPLLineList;
    SV,SH: TScrollInfo;
    constructor Create(AOwner: TComponent);
    destructor Destroy; override;

    procedure WMVScroll(var Message: TWMVScroll); message WM_VSCROLL;
    procedure WMHScroll(var Message: TWMHScroll); message WM_HSCROLL;

    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,
                  Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;

    procedure Paint; override;
    procedure Resize; override;
    procedure SetupScrollBars;
  published

  end; // TPlListBox

implementation

{ TPlListBox }

constructor TPlListBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Lines:=TPLLineList.Create;
  Lines.Canvas:=Canvas;
end;

destructor TPlListBox.Destroy;
begin
  inherited Destroy;
end;

procedure TPlListBox.WMVScroll(var Message: TWMVScroll);
begin
 with Lines do
   case Message.ScrollCode of
     SB_TOP: ViewRect.Top:=0;
     SB_BOTTOM: ViewRect.Top:= ViewRect.Bottom;

     SB_LINEUP: begin
       dec(ViewRect.Top, GetHighLineHeight(FirstLine-2, FirstLine))
     end; // SB_LINEUP

     SB_LINEDOWN: begin
       Inc(ViewRect.Top, GetHighLineHeight(LastLine, LastLine+2 ))
     end; // SB_LINEDOWN

     SB_PAGEUP: begin
//       if ViewRect.Top > ClientHeight-1 then
  //       Dec(ViewRect.Top, ClientHeight);
     end; // SB_PAGEUP

     SB_PAGEDOWN: begin
       if ViewRect.Top <= SV.nMax then
         Inc(ViewRect.Top, sv.nPage)
       else
         ViewRect.Top:=sv.nPage+ClientHeight;
     end; // SB_PAGEDOWN

     SB_THUMBTRACK,SB_THUMBPOSITION: begin
       SV.cbSize := SizeOf(SV);
       SV.fMask := SIF_TRACKPOS;
       GetScrollInfo(Handle, SB_Vert, SV);
       Lines.ViewRect.Top:=sv.nTrackPos;
//       matchFirstLastLine(sv.nTrackPos);
     end;
     else
       exit;
   end; // Of Case
  SetupScrollBars;
  paint;
end; // TPlListBox.WMVScroll

procedure TPlListBox.WMHScroll(var Message: TWMHScroll);
begin

end; // TPlListBox.WMHScroll

procedure TPlListBox.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
  Lines.ItemIndex:=Lines.GetIndexFromXY(x,y);
end; // TPlListBox.MouseDown

procedure TPlListBox.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseMove(Shift, X, Y);
  Lines.HotItemIndex:=lines.GetIndexFromXY(x,y);
end;

procedure TPlListBox.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited KeyDown(Key, Shift);
  case Key of
    VK_UP: begin
      if Lines.ItemIndex-1 >=0 then begin
        Lines.ItemIndex:=Lines.ItemIndex-1;
        Lines.SetViewRecTop(Lines.ItemIndex);
        SetupScrollBars;
        Paint;
      end;
    end; // VK_UP

    VK_DOWN: begin
      if Lines.ItemIndex+1 <=Lines.GetCount-1 then begin
        Lines.ItemIndex:=Lines.ItemIndex+1;
        Lines.SetViewRecTop(Lines.ItemIndex);
        SetupScrollBars;
        Paint;
      end;
    end; // VK_DOWN

    VK_F2: begin
      Randomize;
      Lines.ItemIndex:=Random(Lines.GetCount);
      Lines.SetViewRecTop(Lines.ItemIndex);
      SetupScrollBars;
      Paint;
    end; // vk_f2
  end; // case
end;

procedure TPlListBox.Paint;
var
  i,y:integer;
begin
  inherited Paint;
//  Canvas.Brush.Color:=clWhite;
//  Canvas.Rectangle(0,0,Width,Height);
  Lines.Paint;
//  y:=0;
end; // TPlListBox.Paint

procedure TPlListBox.Resize;
begin
  inherited Resize;
  Lines.SetBufferSize(Width,ClientHeight);
  SetupScrollBars;
end; // TPlListBox.Resize

procedure TPlListBox.SetupScrollBars;
begin
  if (HandleAllocated) then begin
    if (Lines.GetCount >0) then begin
      SV.cbSize := SizeOf(SV);
      SV.fMask := SIF_POS or SIF_RANGE or SIF_PAGE or SIF_DISABLENOSCROLL;
      SV.nPos := Lines.ViewRect.Top;
      SV.nMin := 0;
      SV.nMax := Lines.GetTextHeight;
      SV.nPage:= Lines.ViewRect.Bottom;
      SetScrollInfo(Handle, SB_Vert, SV, True);
      Lines.ViewRect.Top:=sv.nPos;
    end;

   { if (fTextBuffer.LastColum > 0) and (fTextBuffer.LongstColumn >=fTextBuffer.LastColum) then begin
      SH.cbSize := SizeOf(SH);
      SH.fMask := SIF_POS or SIF_RANGE or SIF_PAGE or SIF_DISABLENOSCROLL;
//      writeln(fTextBuffer.LineList[CaretY].LineItem[fTextBuffer.FirstColum].symbol);
      SH.nPos := fTextBuffer.FirstColum;
      SH.nMin := 0;
      SH.nMax := fTextBuffer.LongstColumn;
      SH.nPage:= fTextBuffer.ColumPerPage;
      SetScrollInfo(Handle, SB_Horz, SH, true);
    end;}
  end
end; // TPlListBox.SetupScrollBars

end.

